'****************************************************************
'*  Name    : NRF24l01+_mode_recever.BAS                                      *
'*  Author  : =MiX@$=                                           *
'*  Notice  : Copyright (c) 2014 =MiX@$=                        *
'*          : All Rights Reserved                               *
'*  Date    : 25.07.2014                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
 '            PWR_UP, PRIM_RX   CE 
 

 Device = 16F877A
 Xtal 20

' ================================ LCD ===============================================
                          
Declare LCD_Type ALPHA            '   - - 
Declare LCD_DTPin PORTB.4         '    
Declare LCD_ENPin PORTB.2         '   E 
Declare LCD_RSPin PORTB.3         '   RS 
Declare LCD_Interface 4           ' 4-      
Declare LCD_CommandUs 2000        '     
Declare LCD_DataUs 50             '     
Declare LCD_Lines 2               '    

TRISA = %00000010    
TRISB = %00000000
TRISC = %11111111
ADCON1 = %00000111

Clear PORTB
Clear PORTA
Symbol MO  = PORTB.0              ' MoSi
Symbol SCK = PORTB.1              ' 
Symbol NRF_CSN  = PORTA.0              ' Select slave 
Symbol MI  = PORTA.1              ' MiSo
Symbol NRF_CE  = PORTA.2              ' Chip enable
Symbol NRF_IRQ  = PORTC.0             ' 
Symbol SW1      = PORTC.1       ' Switch - pin has pullup - pressing pulls down to VSS

Dim rxled_state As Bit                          ' the state of the rx LED
    Dim i As Byte                                   ' index for loops and arrays
    Dim temp_byte As Byte
    Dim nrf_ptr As Byte                             ' array pointer
    Dim spi_array[16] As Byte                       ' SPI transmit array
    Dim nrf_inx As Byte                             ' SPI loop index
    Dim nrf_channel As Byte                         ' intialize with default value
    Dim nrf_address As Dword                        ' Pipe 0 4 byte address - real address be read from EEPROM
    Dim nrf_rfsetup As Byte
    Dim nrf_setretr As Byte
    Dim NRF_Status As Byte                          ' status byte
    Dim nrf_errf As Byte                            ' error flgas
    Dim prom1 As Byte
    Dim prom2 As Byte
    Dim prom3 As Byte
    
    Symbol W_REGISTER         = 0x20                ' Address 0 Write Register command
    Symbol R_REGISTER         = 0x00                ' Address 0 Read Register command
    Symbol R_RX_PAYLOAD       = 0x61                ' Read RX spi_array
    Symbol W_TX_PAYLOAD       = 0xA0                ' Write TX spi_array
    Symbol FLUSH_TX           = 0xE1                ' Flush TX FIFO
    Symbol FLUSH_RX           = 0xE2                ' Flush RX FIFO
    Symbol REUSE_TX_PL        = 0xE3                ' Reuse last sent spi_array
    Symbol R_RX_PL_WID        = 0x60                ' read RX spi_array width for the top Rx spi_array in the FIFO
    Symbol W_ACK_PAYLOAD      = 0xA8                ' RX mode: write spi_array to be transmitted with ACK packet mask for last 3 bits in range 000 - 101
    Symbol W_TX_PAYLOAD_NOACK = 0xB0                ' Disable auto ACK on the specific packet
    Symbol NRF_NOP            = 0xFF                ' Reuse last sent spi_array
   Dim humidityRH As Float
    Dim temperatureC As Float
     temperatureC = 0.0
     humidityRH = 0.0

GoTo Main
SPI_READ:
 NRF_CSN = 0
   
SHOut MO,SCK, MsbFirst, [spi_array[0]]
  SHIn MI,SCK, 0, [spi_array[1]]
NRF_CSN = 1
   
Return

SPI_READ2:
 NRF_CSN = 0
   
SHOut MO,SCK, MsbFirst, [spi_array[0]]
  SHIn MI,SCK, 0, [spi_array[1],spi_array[2]]
NRF_CSN = 1
   
Return

SPI_READ4:
 NRF_CSN = 0
   
SHOut MO,SCK, MsbFirst, [spi_array[0]]
  SHIn MI,SCK, 0, [spi_array[1],spi_array[2],spi_array[3],spi_array[4]]
NRF_CSN = 1
   
Return

Check_SPI:
 NRF_CSN = 0

 prom3 = spi_array[0]
 ClearBit prom3, 5
 
SHOut MO,SCK, MsbFirst, [prom3]
  SHIn MI,SCK, 0, [prom2]
NRF_CSN = 1
  If prom2 != prom1 Then Cls : Print At 1,1, Hex2 prom3, "-Bad register " : Print At 2,1, "Out: ",Hex2 prom1,"   In: ", Hex2 prom2 : Stop
    
Return

Check_SPI4:
 NRF_CSN = 0

 prom3 = spi_array[0]
 ClearBit prom3, 5
 
SHOut MO,SCK, MsbFirst, [prom3]
  SHIn MI,SCK, 0, [spi_array[10],spi_array[11],spi_array[12],spi_array[13]]
NRF_CSN = 1
  If prom2 != prom1 Then Cls : Print At 1,1, Hex2 prom3, "-Bad register " : Print At 2,1, Hex2 spi_array[10],Hex2 spi_array[11],Hex2 spi_array[12],Hex2 spi_array[13] : Stop
    
Return

'---[SPI sub for the NRF24L01+]-------------
SPI_NRF: 
NRF_CSN = 0      
    SHOut MO,SCK, MsbFirst, [spi_array[0]]
NRF_CSN = 1               
Return  
    
SPI_NRF2:
NRF_CSN = 0 
SHOut MO,SCK, MsbFirst, [spi_array[0],spi_array[1]]
NRF_CSN = 1               
Return    

'=========================================
SPI_NRF4: 
NRF_CSN = 0
SHOut MO,SCK, MsbFirst, [spi_array[0],spi_array[1],spi_array[2],spi_array[3],spi_array[4]]
NRF_CSN = 1              
Return  

SPI_NRF8: 
NRF_CSN = 0
SHOut MO,SCK, MsbFirst, [spi_array[0],spi_array[1],spi_array[2],spi_array[3],spi_array[4],spi_array[5],spi_array[6],spi_array[7],spi_array[8]]
NRF_CSN = 1              
Return   
'
Load_NRF:
    nrf_channel = 0x02                              ' Channel #2
    nrf_address = 0xCFE7E7CF                        ' some address
    nrf_rfsetup = 0x26                              ' 00100110 => 250kbps, 0dBm 
    nrf_setretr = 0x38                              ' 00100100 => ARD = 1000uS, ARC = 8 
    Return

Init_PTX:
    NRF_CE = 0                                      ' Clear NRF_CE so we can Write to NRF in Standby mode
    '----------------------------------------    
    'REG 00 CONFIG
    NRF_CSN = 0
    spi_array[0] = W_REGISTER                       ' W_REGISTER at address 0x00 => CONFIG
    spi_array[1] = 0x48                             ' 01001000 PTX, PWR_Dn, CRC 1 byte, CRC enabled, MASK_MAX_RT, MASK_TX_DS intterupts reflected on NRF_IRQ
    nrf_ptr = 1
    prom1 = spi_array[1]
    GoSub SPI_NRF2
    NRF_CSN = 1  
    GoSub Check_SPI  
    '----------------------------------------    
    'REG 01 EN_AA   
    NRF_CSN = 0
    spi_array[0] = W_REGISTER | 0x01                ' W_REGISTER At address 0x01 => EN_AA
    spi_array[1] = 0x01                             ' Enable auto-ack on pipes 0 , TX mode
    nrf_ptr = 1
    prom1 = spi_array[1]
    GoSub SPI_NRF2
    NRF_CSN = 1
    GoSub Check_SPI
    '----------------------------------------    
    'REG 03 SETUP AW
    NRF_CSN = 0
    spi_array[0] = W_REGISTER | 0x03                ' W_REGISTER at address 0x03 => SETUP AW
    spi_array[1] = 0x02                             ' Address width = 4 bytes
    nrf_ptr = 1
    prom1 = spi_array[1]
    GoSub SPI_NRF2
    NRF_CSN = 1
    GoSub Check_SPI
    '----------------------------------------    
    'REG 04 SETUP RETR
    NRF_CSN = 0
    spi_array[0] = W_REGISTER | 0x04                ' W_REGISTER at address 0x04 => SETUP RETR
    spi_array[1] = nrf_setretr                      ' auto retransmit values loaded frm LUT
    nrf_ptr = 1
    prom1 = spi_array[1]
    GoSub SPI_NRF2
    NRF_CSN = 1  
    GoSub Check_SPI
    
    '----------------------------------------    
    'REG 05 RF_CH
    NRF_CSN = 0
    spi_array[0] = W_REGISTER | 0x05                ' W_REGISTER at address 0x05 => RF_CH
    spi_array[1] = nrf_channel                      ' default channel = 2
    nrf_ptr = 1
    prom1 = spi_array[1]
    GoSub SPI_NRF2
    NRF_CSN = 1
    GoSub Check_SPI
    '----------------------------------------     
    'REG 06 RF_SETUP
    NRF_CSN = 0 
    spi_array[0] = W_REGISTER | 0x06                ' W_REGISTER at address 0x06 => RF_SETUP
    spi_array[1] = nrf_rfsetup                      ' 0x02 = DR 1Mbps, RF_POWER -12dBm, 0x26 = DR 250kbps, RF_POWER 0dBm 
    nrf_ptr = 1
    prom1 = spi_array[1]
    GoSub SPI_NRF2
    NRF_CSN = 1  
    GoSub Check_SPI  
    '----------------------------------------    
    'REG 07 STATUS 
    NRF_CSN = 0
    spi_array[0] = W_REGISTER | 0x07                ' W_REGISTER at address 0x07 => STATUS
    spi_array[1] = 0x70                             ' Clear RX_DR, TX_DS and  MAX_RT Interrupts %01110000
    nrf_ptr = 1
   
    GoSub SPI_NRF2
    NRF_CSN = 1  
     
    '----------------------------------------      
    'REG 10 TX_ADDR
    NRF_CSN = 0
    spi_array[0] = W_REGISTER | 0x10                ' W_REGISTER at address 0x10 => TX_ADDR
    spi_array[1] = nrf_address.Byte0                ' RX address byte 0 LSByte
    spi_array[2] = nrf_address.Byte1                ' RX address byte 1
    spi_array[3] = nrf_address.Byte2                ' RX address byte 2
    spi_array[4] = nrf_address.Byte3                ' RX address byte 3
    nrf_ptr = 4
    GoSub SPI_NRF4
    NRF_CSN = 1
    GoSub Check_SPI4
    '----------------------------------------    
    'REG 0A RX_ADDR_P0 (Only if ACK is to be received into pipe 0)   
    NRF_CSN = 0
    spi_array[0] = W_REGISTER | 0x0A                ' W_REGISTER at address 0x0A => RX_ADDR_P0
    spi_array[1] = nrf_address.Byte0                ' RX address byte 0 LSByte
    spi_array[2] = nrf_address.Byte1                ' RX address byte 1
    spi_array[3] = nrf_address.Byte2                ' RX address byte 2
    spi_array[4] = nrf_address.Byte3                ' RX address byte 3
    nrf_ptr = 4
    GoSub SPI_NRF4
    NRF_CSN = 1
    GoSub Check_SPI4
    '----------------------------------------         
    'REG 0x1C DYNPD    
    NRF_CSN = 0
    spi_array[0] = W_REGISTER | 0x1C                ' W_REGISTER at address $1C => DYNPD (Dynamic Payload)
    spi_array[1] = 0x01                             ' enable dynamic payload on Pipe0
    nrf_ptr = 1
    prom1 = spi_array[1]
    GoSub SPI_NRF2
    NRF_CSN = 1
    GoSub Check_SPI
    '----------------------------------------        
    ;REG 0x1D FEATURE    
    NRF_CSN = 0
    spi_array[0] = W_REGISTER | 0x1D                ' W_REGISTER at address $1D => FEATURE
    spi_array[1] = 0x04                             ' 0x04 If we don't need ack with payload
    nrf_ptr = 1
    prom1 = spi_array[1]
    GoSub SPI_NRF2
    NRF_CSN = 1
    GoSub Check_SPI
    
    Print At 1,1, "Init Ok!"
    DelayMS 2000                            ' Critical! min 1500uS Tpd2stby delay 
    Cls      
    '----------------------------------------        
    Return   
'
FLUSH_TX_FIFO:                                      ' flush all TX FIFO slots  
    spi_array[0] = FLUSH_TX
    nrf_ptr = 0
    NRF_CSN = 0
    GoSub SPI_NRF
    NRF_CSN = 1
    Return    
'
NRF_PWRDN:                                          ' power Down
    NRF_CSN = 0                                     ' enable Slave
    spi_array[0] = W_REGISTER                       ' W_REGISTER at address $00 => CONFIG
    spi_array[1] = 0x48                             ' PTX, PWR_DN, CRC 1 Byte, CRC enabled, MASK_MAX_RT, MASK_TX_DS intterupts reflected On NRF_IRQ
    nrf_ptr = 1
    GoSub SPI_NRF2
    NRF_CSN = 1                         
    Return
'
TX_POWERUP:                                         ' Power up
    spi_array[0] = W_REGISTER                       ' CONFIG Register
    spi_array[1] = 0x4A                             ' PTX, PWR_UP, CRC 1 Byte, CRC enabled, MASK_MAX_RT, MASK_TX_DS intterupts reflected On NRF_IRQ 
    nrf_ptr = 1
    NRF_CSN = 0
    GoSub SPI_NRF2
    NRF_CSN = 1
    DelayUS 3000                                    ' Critical! min 1500uS Tpd2stby delay 
    GoSub FLUSH_TX_FIFO
    Return
'
READ_NRF_STATUS:                                    ' read STATUS for Interrupt source 
    spi_array[0] = R_REGISTER | 0x07                ' Read Register $07 => STATUS
    nrf_ptr = 0
    NRF_CSN = 0
    GoSub SPI_READ  
    NRF_CSN = 1    
    NRF_Status = (spi_array[1] >> 4) & 7            ' shift and mask so we have bits 6:4 in place [2:0] bit2=RX_DR, bit1 = TX_DS, bit0 = MAX_RT        
    Return
'
CLR_NRF_INT:                                        ' Clear Interrupts   
    spi_array[0] = W_REGISTER | 0x07                ' W_REGISTER at address $07 => STATUS
    spi_array[1] = 0x70                             ' Clear all Interrupts
    nrf_ptr = 1
    NRF_CSN = 0
    GoSub SPI_NRF2  
    NRF_CSN = 1    
    Return           
'
NRF_Transmit:
   
     temperatureC = temperatureC + 0.01
     humidityRH = humidityRH + 0.1
    spi_array[0] = W_TX_PAYLOAD                     ' TX payload command
    spi_array[1] = humidityRH.Byte0
    spi_array[2] = humidityRH.Byte1
    spi_array[3] = humidityRH.Byte2
    spi_array[4] = humidityRH.Byte3
    
    spi_array[5] = temperatureC.Byte0
    spi_array[6] = temperatureC.Byte1
    spi_array[7] = temperatureC.Byte2
    spi_array[8] = temperatureC.Byte3
    
    GoSub SPI_NRF8
    High NRF_CE                                     ' transmit 
    DelayUS 20
    Low NRF_CE
    '
    nrf_errf = 0                                    ' clear error flag here
    
    While NRF_IRQ = 1                               ' wait for NRF_IRQ pin goes low
         
           nrf_errf = 0x0F                         ' set the error flags to 15so LED will flash 8 times
            NRF_Status = 0
            'Print At 1,1," Wait.."
    Wend 
   'delayms 5                
    '
    GoSub READ_NRF_STATUS                           ' read STATUS for Interrupt source and shif >> 4 to lower nible NRF_Status.2 = RX_DR, NRF_Status.1 = TX_DS, NRF_Status.0 = MAX_RT
    Print At 1,1,Hex2 NRF_Status, "       "
    'DelayMS 100
    GoSub CLR_NRF_INT                               ' Clear Interrupts 
    If NRF_Status = 0x02 Then Return                ' good Ack no payload = 0x02        
    If NRF_Status.0 = 0x01 Then nrf_errf = 4        ' MAX_RT no ack LED flash twice
    Return
    '
'---[main control loop]--------------    
Main:
   Cls    
    High NRF_CSN                                    ' unselect NRF slave
    Low NRF_CE                                      ' clear CE until we start working    
   
    DelayMS 250
    GoSub Load_NRF
    GoSub Init_PTX                  
    '
    
    '
    rxled_state = 0
    '
    While 1 = 1
       ' If SW1 = 0 Then                             ' add which ever anti bounce needed
          DelayMS 1000 
            rxled_state = ~rxled_state              ' to toggle the LED on the Rx
            temp_byte = 0x30 + rxled_state          ' ON = "1" Off = "0"
            GoSub TX_POWERUP                        ' powerup the nrf the first target command is protected in a buffer
            GoSub NRF_Transmit 
            Print At 1,15, Hex rxled_state
            If nrf_errf != 0 Then                   ' error indicator
                Print At 2,1, Hex2 nrf_errf, "    ":
            EndIf
            GoSub NRF_PWRDN                         ' power down the NRF
        '    DelayMS 200
            
            Clear spi_array
            'While SW1 = 0 : Wend                    ' wait to release switch
       ' EndIf
        'DelayMS 200                                 ' loop delay
    Wend    

